package
{
	import flash.display.Bitmap;
	import flash.display.Shape;
	import flash.events.Event;
	import flash.external.*;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.*;
	import flash.ui.Mouse;
	
	import mx.utils.StringUtil;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class TitleState extends FlxState
	{
		[Embed(source = "data/gam1.mp3")] public static var SndGam1:Class;
		[Embed(source = "data/gam2.mp3")] public static var SndGam2:Class;
		[Embed(source = "data/gam3.mp3")] public static var SndGam3:Class;
		[Embed(source = "data/gam4.mp3")] public static var SndGam4:Class;
		[Embed(source = "data/gam5.mp3")] public static var SndGam5:Class;
		[Embed(source = "data/gam6.mp3")] public static var SndGam6:Class;
		[Embed(source = "data/gam7.mp3")] public static var SndGam7:Class;
		[Embed(source = "data/gam8.mp3")] public static var SndGam8:Class;


		[Embed(source = "data/noiseblip.mp3")] public static var SndNoiseBlip:Class;
		[Embed(source = "data/heavyblip.mp3")] public static var SndHeavyBlip:Class;
		[Embed(source = "data/lightblip.mp3")] public static var SndLightBlip:Class;
		[Embed(source = "data/button.png")] public static var ImgUndo:Class;
		[Embed(source = "data/buttonhover.png")] public static var ImgUndoHover:Class;
		[Embed(source = 'data/levels.txt', mimeType = "application/octet-stream")] private var LevelTextFile:Class;
		
		public static var level_strings:Vector.<String>;
		public static var level_names:Vector.<String>;
		
		public var tripodstring:String = "E 0,1 0,3 0,2|160.99641121933672,270.99348083496255,1 188.92277882948474,324.49941457276253,1 193.37072528463847,220.05557018037274,1 100.69572954696872,268.4254577388915,1"
		public var tripodstring2:String = "E 0,1 0,3 0,2|245.9996399561826,394.9788310321923,1 264.0726167815658,452.56471872566146,1 286.83399318665823,350.5342301299135,1 187.09230990027902,381.83754423461465,1";
		
		public var graphstate:GraphState;
		public var graphstate2:GraphState;
		public var undos:Vector.<GraphState>;
		public var undos2:Vector.<GraphState>;
		
		public const delta:Number=20;
		
		public var sucking:Boolean;
		public var fading:Boolean;
		private var suckingto:int;
		public var suckingverts:Vector.<int>;
		public var suckingfrom:Vector.<FlxPoint>;
		public var sucktime:Number;
		public const sucklength:Number=0.5;
		
		public var playmode:Boolean;
		
		public var mousedown:Boolean;
		public var mousetarget:int;
		public var movedfar:Boolean;
		public var movedfrom:FlxPoint;
		public var mousegraph:int;
		public const maxdist:Number = 7;
		
		public const bgcolor:uint = 		0xffffffff;
		public const vertexcolor:uint = 	0xff0000;
		public const edgecolor:uint = 		0x000000;
		public const highlightcolor:uint = 	0xff7777;
		public const vertexradius:Number = 10;
		public const linewidth:Number = 3;
		
		private function callFromJavaScript(dir:String):void 
		{
			trace("called from");
			var g:GraphState = GraphState.Read(dir);
			if (g!=null)
			{		
				graphstate=g;
				fromindex=-1;
				selected="";
				mousetarget=-1;
				mousedown=false;
			}
		}
		override public function create() : void
		{	
			FlxG.flash.start(0xff000000,1,null,true);
			level_strings= new Vector.<String>();
			level_names = new Vector.<String>();
			var s:String = new LevelTextFile();
			var levelfilelines:Array = s.split("\n");
			for (var i:int=0;i<levelfilelines.length;i++)
			{
				var line:String = levelfilelines[i];
				line=mx.utils.StringUtil.trim(line);
				if (line.length==0)
					continue;
				
				if (level_names.length==level_strings.length)
				{
					//load name
					level_names.push(line);
				}
				else
				{
					level_strings.push(line);
				}
			}
			
			fading=false;
			//call from javascript
			ExternalInterface.addCallback("sendToActionscript", callFromJavaScript);
			
			bgColor=bgcolor;
			
			mousedown=false;
			mousetarget=-1;
			movedfar=false;
			movedfrom = new FlxPoint(0,0);
			
			playmode=true;
			created=false;
			super.create();
			
			
			FlxG.level=0;
			var save:FlxSave = new FlxSave();			
			if (save.bind("MG"))
			{
				FlxG.level =  save.data.level;				
			}
			if (FlxG.level>=level_names.length)
				FlxG.level=0;
			
			//graphstate = new GraphState();
			graphstate = GraphState.Read(tripodstring);
			undos = new Vector.<GraphState>();
			
			if (FlxG.level>0)
			{
				graphstate2 = GraphState.Read(tripodstring2);
			}
			undos2 = new Vector.<GraphState>();
			

			fromindex=-1;
			selected="";
			selectedgraph=0;
			suckingverts = new Vector.<int>();
			suckingfrom = new Vector.<FlxPoint>();
			sucking=false;
			hardcore=null;
			
			var titletxt:FlxText = new FlxText(0,100,FlxG.width,"CATALAN");
			titletxt.color=0xff000000;
			titletxt.size=100;
			titletxt.alignment="center";
			this.add(titletxt);
			
			starttxt = new FlxText(0,100,FlxG.width,"NEW GAME");
			starttxt.color=0xff000000;
			starttxt.size=60;
			starttxt.alignment="left";
			this.add(starttxt);
			
			
			if (FlxG.level>0)
			{
				continuetxt = new FlxText(0,100,FlxG.width,"CONTINUE");
				continuetxt.color=0xff000000;
				continuetxt.size=60;
				continuetxt.alignment="left";
				this.add(continuetxt);
			}
			
		}
		
		private var starttxt:FlxText;
		private var continuetxt:FlxText;
		private var hardcore:HardcoreGenerator;
		
		private function Snapshot():void
		{
			undos.push(graphstate.Copy());
			undos2.push(graphstate.Copy());
		}
		
		private var suckinggraph:int;
		private function TrySuckAbout(graph:int,v:int) : void
		{
			suckinggraph=graph;
			if (graph==1)
			{
				suckingverts = graphstate.VertexNeighbours(v);
			}
			else if (graph==2)
			{
				suckingverts = graphstate2.VertexNeighbours(v);
			}
			
			if (suckingverts.length==3)
			{
				sucking=true;
				suckingto=v;
				suckingfrom = new Vector.<FlxPoint>();
				for (var i:int=0;i<suckingverts.length;i++)
				{
					var vertex:FlxPoint;
					if (graph==1)
					{
						vertex = graphstate.vertices[suckingverts[i]];
					}
					else if (graph==2)
					{
						vertex = graphstate2.vertices[suckingverts[i]];
					}
					
					suckingfrom.push(new FlxPoint(vertex.x,vertex.y));
				}
				sucktime=0;
			}
		}
		
		public static function segmentdist(segA:FlxPoint, segB:FlxPoint, p:FlxPoint):Number
		{
			var p2:Point = new Point(segB.x - segA.x, segB.y - segA.y);
			var something:Number = p2.x*p2.x + p2.y*p2.y;
			var u:Number = ((p.x - segA.x) * p2.x + (p.y - segA.y) * p2.y) / something;
			
			if (u > 1)
				u = 1;
			else if (u < 0)
				u = 0;
			
			var x:Number = segA.x + u * p2.x;
			var y:Number = segA.y + u * p2.y;
			
			var dx:Number = x - p.x;
			var dy:Number = y - p.y;
			
			var dist:Number = Math.sqrt(dx*dx + dy*dy);
			
			return dist;
		}
		
		private var selected:String;
		private var selectedindex:int;
		private var selectedgraph:int;
		
		private var fromindex:int;
		private var fromgraph:int;
		private var created:Boolean;
		
		override public function update() : void
		{
			
			if (hardcore!=null)
			{
				hardcore.tick();
				if (hardcore.numberleft<=0)
				{					
					var g:GraphState = hardcore.maxdat.curmax;
					if (g!=null)
					{
						FlxG.play(TitleState.SndLightBlip);
						graphstate = g;
						graphstate.Gridify(new Rectangle(0,0,FlxG.width,FlxG.height));
						trace("solution found");
						
						trace(hardcore.maxdat.maxwin,hardcore.maxdat.maxlose);
						hardcore=null;
					}
					else
					{
						FlxG.play(TitleState.SndHeavyBlip);
						trace("solution not found");
					}
				}
			}
									
			var minedgedist:Number=100000;
			var minedgeindex:int=-1;
			var minvertexdist:Number=100000;
			var minvertexindex:int=-1;
			var mousepos:FlxPoint = new FlxPoint(FlxG.mouse.x,FlxG.mouse.y);
			if (mousepos.x<0)
				mousepos.x=0;
			if (mousepos.x>=FlxG.width)
				mousepos.x=FlxG.width;
			if (mousepos.y<0)
				mousepos.y=0;
			if (mousepos.y>=FlxG.height)
				mousepos.y=FlxG.height;
			
			for (var i:int=0;i<graphstate.vertices.length;i++)
			{
				var d:Number = dist(mousepos,graphstate.vertices[i]);
				if (d<=delta && d<minvertexdist)
				{
					minvertexdist=d;
					minvertexindex=i;
					selectedgraph=1;
				}
			}
			
			if (FlxG.level>0)
			{
			for (i=0;i<graphstate2.vertices.length;i++)
			{
				d = dist(mousepos,graphstate2.vertices[i]);
				if (d<=delta && d<minvertexdist)
				{
					minvertexdist=d;
					minvertexindex=i;
					selectedgraph=2;
				}
			}
			}
			
			if (playmode)
			{
				if (minvertexindex>=0)
				{
					selected="vertex";
					selectedindex=minvertexindex;
				}
				else
				{
					selected="";
				}
				
				if (sucking)
				{
					this.sucktime+=FlxG.elapsed;
					
					for (i=0;i<this.suckingverts.length;i++)
					{
						var v:int = suckingverts[i];
						if (suckinggraph==1)
						{
							graphstate.vertices[v].x=suckingfrom[i].x+(sucktime/sucklength)*(graphstate.vertices[suckingto].x-suckingfrom[i].x);
							graphstate.vertices[v].y=suckingfrom[i].y+(sucktime/sucklength)*(graphstate.vertices[suckingto].y-suckingfrom[i].y);
						}
						else
						{
							graphstate2.vertices[v].x=suckingfrom[i].x+(sucktime/sucklength)*(graphstate2.vertices[suckingto].x-suckingfrom[i].x);
							graphstate2.vertices[v].y=suckingfrom[i].y+(sucktime/sucklength)*(graphstate2.vertices[suckingto].y-suckingfrom[i].y);
						}
					}
					
					if (sucktime>this.sucklength)
					{
						if (suckinggraph==1)
						{
							graphstate.SuckOperation(this.suckingto);
						}
						else if (suckinggraph==2)
						{
							graphstate2.SuckOperation(this.suckingto);							
						}
						
						selected="";
						selectedindex=-1;
						sucking=false;
						fading=true;
						TitleState.PlayBing();
						TitleState.PlayBing();
						FlxG.fade.start(0xff000000,1,OnFaded,true);												
					}
				}
				else if (fading)
				{
					
				}
				else
				{
					graphstate.updateWithForces(FlxG.elapsed);
					if (FlxG.level>0)
					{
						graphstate2.updateWithForces(FlxG.elapsed);
					}
					
					if (FlxG.mouse.justPressed())
					{
						if (minvertexindex>=0)
						{
							mousedown = true;
							mousegraph=selectedgraph;
							mousetarget = minvertexindex;
							movedfar = false;
							movedfrom = new FlxPoint(mousepos.x,mousepos.y);
						}
					}
					
					if (mousedown)
					{					
						if (mousegraph==1)
						{
							this.graphstate.vertices[mousetarget].x=mousepos.x;
							this.graphstate.vertices[mousetarget].y=mousepos.y;
						}
						else
						{
							this.graphstate2.vertices[mousetarget].x=mousepos.x;
							this.graphstate2.vertices[mousetarget].y=mousepos.y;					
						}
						
						if (dist(mousepos,movedfrom)>maxdist)
						{
							movedfar=true;
						}
						if (FlxG.mouse.justReleased())
						{							
							mousedown=false;							
							Snapshot();
							if (!movedfar)
							{
								TrySuckAbout(mousegraph,mousetarget);
							}
						}
					}
				}
			}
			else
			{
				
				
				if (fromindex==-1)
				{
					for (i=0;i<graphstate.edges.length;i++)
					{
						d = segmentdist(graphstate.vertices[graphstate.edges[i].a],graphstate.vertices[graphstate.edges[i].b],mousepos);
						if (d<=delta && d<minedgedist)
						{
							minedgedist=d;
							minedgeindex=i;
						}							
					}
				}
				
				if (minedgeindex!=-1 && minvertexindex==-1)
				{				
					selected="edge";
					selectedindex=minedgeindex;
				}
				else if (minedgeindex==-1 && minvertexindex!=-1)
				{
					selected="vertex";
					selectedindex=minvertexindex;
				}
				else if (minedgeindex!=-1 && minvertexindex !=-1)
				{
					selected="vertex";
					selectedindex=minvertexindex;				
				}
				else
				{
					selected="";
					selectedindex=-1;
				}			
				
				if (FlxG.mouse.justPressed())
				{
					if (selected=="")
					{
						Snapshot();
						graphstate.vertices.push(new Vertex(FlxG.mouse.x,FlxG.mouse.y));		
						created=true;
						selected="vertex";
						selectedindex=graphstate.vertices.length-1;
						fromindex=-1;
					}
					
					if (selected=="vertex")
					{
						fromindex=selectedindex;
					}
					else if (selected=="edge")
					{
						Snapshot();
						graphstate.TryRemoveEdge(selectedindex);
						selected="";
						selectedindex=-1;
					}
				}
				else if (FlxG.mouse.justReleased())
				{
					if (fromindex!=-1)
					{
						if (selectedindex!=-1)
						{
							if ( (fromindex==selectedindex) && (!created))
							{
								Snapshot();
								graphstate.TryRemoveVertex(fromindex);
								
								
								
								for (i=0;i<suckingverts.length;i++)
								{
									if (suckingverts[i]>fromindex)
									{
										suckingverts[i]--;
									}
								}
								
								
								fromindex=-1;
								selectedindex=-1;
								selected="";
							}
							else
							{
								Snapshot();
								var p:IntPair = new IntPair(fromindex,selectedindex);
								graphstate.TryAddEdge(p);
							}
						}
						else
						{
							Snapshot();
							graphstate.vertices.push(new Vertex(FlxG.mouse.x,FlxG.mouse.y))
							p = new IntPair(fromindex,graphstate.vertices.length-1);
							graphstate.TryAddEdge(p);
							
							//nothing
						}
						
					}
					created=false;				
				}				
				
				if (FlxG.keys.justPressed("D"))
				{
					graphstate = new GraphState();
					selected="";
					fromindex=-1;
				}								
			
			}			
			
			
			if (selected=="vertex")
			{
				for (i=0;i<numbers.length;i++)
				{
					if (FlxG.keys.justPressed(numbers[i]))
					{
						trace("type set to"+i);
						graphstate.vertices[selectedindex].type=i;
					}
				}				
			}
			
			if (FlxG.mouse.pressed()==false)
			{
				fromindex=-1;			
			}
			starttxt.x=graphstate.vertices[0].x+30;
			starttxt.y=graphstate.vertices[0].y-15;
			
			if (FlxG.level>0)
			{
				continuetxt.x=graphstate2.vertices[0].x+30;
				continuetxt.y=graphstate2.vertices[0].y-15;
			}
			super.update();
		}		
		
		public static function PlayBing():void
		{
			var volume:Number=0.15;
			switch(GraphState.RandRange(1,8))
			{
				case 1:
					FlxG.play(TitleState.SndGam1,volume);
					break;
				case 2:
					FlxG.play(TitleState.SndGam2,volume);
					break;
				case 3:
					FlxG.play(TitleState.SndGam3,volume);
					break;
				case 4:
					FlxG.play(TitleState.SndGam4,volume);
					break;
				case 5:
					FlxG.play(TitleState.SndGam5,volume);
					break;
				case 6:
					FlxG.play(TitleState.SndGam6,volume);
					break;
				case 7:
					FlxG.play(TitleState.SndGam7,volume);
					break;
				case 8:
					FlxG.play(TitleState.SndGam8,volume);
					break;
			}
		}
		private var numbers:Array = ["ZERO","ONE","TWO","THREE","FOUR","FIVE","SIX","SEVEN","EIGHT","NINE"];
		private function ColourGraph():void
		{
			for (var i:int=0;i<graphstate.vertices.length;i++)
			{
				if (graphstate.connectionsfrom(i)==3)
				{
					var vertex:Vertex=graphstate.vertices[i];
					var gtemp:GraphState=graphstate.Copy();
					gtemp.SuckOperation(i);
					if (!gtemp.CanWin())
					{
						graphstate.vertices[i].type=1;
					}
					else
					{
						graphstate.vertices[i].type=2;			
					}
				}
				else
				{
					graphstate.vertices[i].type=0;
				}
			}
		}
		
		private function OnFaded():void
		{
			if (suckinggraph==1)
			{
				FlxG.level=0;
				var save:FlxSave = new FlxSave();			
				if (save.bind("MG"))
				{
					save.data.level=FlxG.level;
				}
			}
			FlxG.state = new CutsceneState();
		}
		
		private function dist(a:FlxPoint,b:FlxPoint):Number
		{
			var dx:Number = a.x-b.x;
			var dy:Number = a.y-b.y;
			return Math.sqrt(dx*dx+dy*dy);		
		}
		
		override public function render():void
		{
			super.render();
			/*
			var cx:int = int(target.x)+int(FlxG.scroll.x)+target.beaconx;
			var cy:int = int(target.y)+(FlxG.scroll.y)+target.beacony;
			
			var spr:Robot = target as Robot;
			if (spr!=null)
			{				
			var drawShape:Shape = new Shape();	
			drawShape.graphics.moveTo(cx,cy);		
			if (spr.charging)
			{			
			drawShape.graphics.lineStyle(1, 0xffbb00);	
			drawShape.graphics.lineTo(int(FlxG.scroll.x)+spr.chargetox,int(FlxG.scroll.y)+spr.chargetoy);					
			}
			else if (spr.controlled)
			{
			drawShape.graphics.lineStyle(1, 0x886600);						
			drawShape.graphics.lineTo(cx+r*Math.cos(spr.theta),cy+r*Math.sin(spr.theta));
			}
			FlxG.buffer.draw(drawShape);
			}
			
			if (target.charging)
			{
			var circle:Shape = new Shape();
			
			circle.graphics.beginFill(0xffff00,0.1);
			circle.graphics.drawCircle(cx,cy, r);
			circle.graphics.endFill();				
			
			FlxG.buffer.draw(circle);
			}
			}*/
			var shape:Shape = new Shape();
			shape.graphics.lineStyle(linewidth,edgecolor,1.0,true);
			for (i=0;i<graphstate.edges.length;i++)
			{				
				var a:FlxPoint = graphstate.vertices[graphstate.edges[i].a];
				var b:FlxPoint = graphstate.vertices[graphstate.edges[i].b];
				shape.graphics.moveTo(a.x,a.y);
				shape.graphics.lineTo(b.x,b.y);
			}
			
			if (FlxG.level>0)
			{
			for (i=0;i<graphstate2.edges.length;i++)
			{				
				a = graphstate2.vertices[graphstate2.edges[i].a];
				b = graphstate2.vertices[graphstate2.edges[i].b];
				shape.graphics.moveTo(a.x,a.y);
				shape.graphics.lineTo(b.x,b.y);
			}
			}
			
			var thiscolor:uint;
			for (var i:int=0;i<graphstate.vertices.length;i++)
			{
				switch (graphstate.vertices[i].type)
				{
					case 0:
						thiscolor=0xff000000;
						break;
					case 1:
						thiscolor=0xffff0000;
						break;
					case 2:
						thiscolor=0xff0000ff;
						break;
					case 3:
						thiscolor=0x00000000;
						break;
				}
				if (thiscolor==0)
					continue;
				shape.graphics.lineStyle(linewidth,thiscolor,1.0,true);
				shape.graphics.drawCircle(graphstate.vertices[i].x,graphstate.vertices[i].y,vertexradius);
			}
			
			if (FlxG.level>0)
			{
			for (i=0;i<graphstate2.vertices.length;i++)
			{
				switch (graphstate2.vertices[i].type)
				{
					case 0:
						thiscolor=0xff000000;
						break;
					case 1:
						thiscolor=0xffff0000;
						break;
					case 2:
						thiscolor=0xff0000ff;
						break;
					case 3:
						thiscolor=0x00000000;
						break;
				}
				if (thiscolor==0)
					continue;
				shape.graphics.lineStyle(linewidth,thiscolor,1.0,true);
				shape.graphics.drawCircle(graphstate2.vertices[i].x,graphstate2.vertices[i].y,vertexradius);
			}
			}
			
			//shape.graphics.beginFill(edgecolor,1.0);
			if (selected=="edge")
			{
				if (selectedgraph==1)
				{
					a = graphstate.vertices[graphstate.edges[selectedindex].a];
					b = graphstate.vertices[graphstate.edges[selectedindex].b];
					shape.graphics.moveTo(a.x,a.y);
					shape.graphics.lineTo(b.x,b.y);
				}
				else if (selectedgraph==2)
				{
					a = graphstate2.vertices[graphstate2.edges[selectedindex].a];
					b = graphstate2.vertices[graphstate2.edges[selectedindex].b];
					shape.graphics.moveTo(a.x,a.y);
					shape.graphics.lineTo(b.x,b.y);					
				}
			}
			
			else if (selected=="vertex")
			{
				if (selectedgraph==1)
				{
					shape.graphics.lineStyle(2,highlightcolor,2,true);
					shape.graphics.drawCircle(graphstate.vertices[selectedindex].x,graphstate.vertices[selectedindex].y,vertexradius);
				}
				else if (selectedgraph==2)
				{					
					shape.graphics.lineStyle(2,highlightcolor,2,true);
					shape.graphics.drawCircle(graphstate2.vertices[selectedindex].x,graphstate2.vertices[selectedindex].y,vertexradius);
				}					
			}
			shape.graphics.lineStyle(2,highlightcolor,linewidth,true);
			
			if (this.fromindex!=-1)
			{
				a = graphstate.vertices[fromindex];
				if (selected=="vertex")
				{
					b = new FlxPoint(graphstate.vertices[selectedindex].x,graphstate.vertices[selectedindex].y);					
				}
				else
				{
					b = new FlxPoint(FlxG.mouse.x,FlxG.mouse.y);
				}
				
				shape.graphics.moveTo(a.x,a.y);
				shape.graphics.lineTo(b.x,b.y);
			}
			
			//shape.graphics.moveTo(0,0);
			//shape.graphics.lineTo(FlxG.mouse.x,FlxG.mouse.y);
			FlxG.buffer.draw(shape);			
		}
	}
	
}
import flash.geom.Rectangle;

import mx.utils.StringUtil;

import org.flixel.FlxG;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;

class Vertex extends FlxPoint
{ 
	public var velocity:FlxPoint = new FlxPoint();
	// force twards other vertices in the network
	public var net_force:FlxPoint = new FlxPoint();
	public var isDragged:Boolean = false;  // I can drag the vertex
	public var type:int;
	public function Vertex(_x:Number,_y:Number,_type:int=0)
	{
		super(_x,_y);
		type=_type;
	}
}

class GenStruct
{
	public var curmax:GraphState;
	public var maxdiff:int=0;
	public var maxwin:int;
	public var maxlose:int;	
	public var totick:int;
	public function GenStruct()
	{
		
	};
}
class HardcoreGenerator
{
	
	public var maxdat:GenStruct;
	public var numberleft:int;
	public function HardcoreGenerator()
	{
		numberleft=1000000000;
		maxdat = new GenStruct();
		maxdat.curmax=null;
		maxdat.maxdiff=0;
		maxdat.maxwin=0;
		maxdat.maxlose=0;	
		maxdat.totick=10;
	}
	
	public function tick():void
	{
		//trace("tick");
		//numberleft-=maxdat.totick;
		GraphState.EndGameSearch(maxdat);
	}
}

class GraphState
{
	public var vertices:Vector.<Vertex>;
	public var edges:Vector.<IntPair>;	
	
	public const vforce:Number = 50.0*60.0;
	public const eforce:Number = 0.06*60.0;
	public const edgeforce:Number = 0.1*60.0;
	public const damping:Number = 0.78;
	
	public const targetedgelength:Number = 80;
	public const scale:Number = 1;
	
	public function Write():String
	{
		var s:String = "";
		for (var i:int=0;i<edges.length;i++)
		{
			if (i>0)
			{
				s+=" ";
			}
			var e:IntPair = edges[i];
			s+=e.a.toString()+","+e.b.toString();
		}
		return s;
	}
	
	
	public function WriteExact():String
	{
		var s:String = "E ";
		
		for (var i:int=0;i<edges.length;i++)
		{
			if (i>0)
			{
				s+=" ";
			}
			var e:IntPair = edges[i];
			s+=e.a.toString()+","+e.b.toString();
		}
		
		s+="|";
		
		for (i=0;i<vertices.length;i++)
		{
			if (i>0)
			{
				s+=" ";
			}
			var v:Vertex = vertices[i];
			s+=v.x.toString() + "," + v.y.toString() + "," + v.type;
		}
		
		return s;
	}
	
	public static function Read(input:String):GraphState
	{
		input=input.concat();
		input = mx.utils.StringUtil.trim(input);
		
		if (input.length==0)
		{
			return null;
		}
		
		var g:GraphState = new GraphState();
		
		var vertexliststring:String="";
		var edgeliststring:String="";
		
		if (input.charAt(0) =="E")
		{
			input=input.substr(1);
			ar = input.split("|");
			vertexliststring=ar[0] as String;
			edgeliststring=ar[1] as String;
		}
		else
		{
			vertexliststring=input;
		}
		
		vertexliststring = mx.utils.StringUtil.trim(vertexliststring);
		edgeliststring = mx.utils.StringUtil.trim(edgeliststring);
		
		var ar:Array=vertexliststring.split(" ");
		
		var maxvertexlabel:int=0;
		for (var i:int=0;i<ar.length;i++)
		{
			var entry:String = ar[i] as String;
			var e_ar:Array = entry.split(",");
			g.edges.push(new IntPair(int(e_ar[0] as String),int(e_ar[1] as String)));
			maxvertexlabel=Math.max(maxvertexlabel,g.edges[ g.edges.length-1].a,g.edges[g.edges.length-1].b);
		}
		
		if (edgeliststring=="")
		{
			for (i=0;i<maxvertexlabel+1;i++)
			{
				g.vertices.push(new Vertex(0,0));
			}
			g.Gridify(new Rectangle(0,0,FlxG.width,FlxG.height));
		}
		else
		{
			var vs_ar:Array = edgeliststring.split(" ");
			
			for (i=0;i<vs_ar.length;i++)
			{
				var v_ar:Array = (vs_ar[i] as String).split(",");
				var v:Vertex = new Vertex(Number(v_ar[0]),Number(v_ar[1]));
				v.type=int(v_ar[2]);
				g.vertices.push(v);
			}
		}
		
		return g;
		
	}
	
	public function connectionsfrom(v:int):int
	{
		var connectioncount:int=0;
		for (var i:int=0;i<edges.length;i++)
		{
			if (edges[i].a==v || edges[i].b==v)
				connectioncount++;
		}
		return connectioncount;
	}
	
	public function updateWithForces(dt:Number):void
	{
		var n:int = vertices.length;
		
		for(var i:int=0; i < n; i++) // loop through vertices
		{
			var v:Vertex = vertices[i];
			var u:Vertex;
			v.net_force.x = v.net_force.y = 0;
			for(var j:int=0; j < n; j++) // loop through other vertices
			{
				if(i==j)continue;
				u = vertices[j];
				// squared distance between "u" and "v" in 2D space
				var rsq:Number = Math.max(((v.x-u.x)*(v.x-u.x)+(v.y-u.y)*(v.y-u.y)),1);
				// counting the repulsion between two vertices
				v.net_force.x += dt * vforce * (v.x-u.x) /rsq;
				v.net_force.y += dt * vforce * (v.y-u.y) /rsq;
			}
		}
		
		for( j=0; j < edges.length; j++) // loop through edges
		{
			var edge:IntPair = edges[j];
			
			var va:Vertex = vertices[edge.a];
			var vb:Vertex = vertices[edge.b];
			
			var edgeVector:FlxPoint = new FlxPoint(vb.x-va.x,vb.y-va.y);
			
			var edgeDir:FlxPoint = edgeVector.unit();
			
			var edgeLength:Number = edgeVector.length();
			
			var factor:Number = (edgeLength-targetedgelength)*edgeforce*dt;
			var targetForce:FlxPoint = new FlxPoint(edgeDir.x*factor,edgeDir.y*factor);
			va.net_force.x +=targetForce.x;
			va.net_force.y +=targetForce.y;
			vb.net_force.x -=targetForce.x;
			vb.net_force.y -=targetForce.y;
			// countin the attraction
			
			va.net_force.x += dt*eforce*(vb.x - va.x);
			va.net_force.y += dt*eforce*(vb.y - va.y);
			vb.net_force.x += dt*eforce*(va.x - vb.x);
			vb.net_force.y += dt*eforce*(va.y - vb.y);			
		}
		
		var dampfactor:Number = Math.pow(damping,60*dt);
		
		for (i=0;i<n;i++)
		{			
			v=vertices[i];
			// counting the velocity (with dumping 0.85)
			if (!isNaN(v.net_force.x*v.net_force.y))
			{
				v.velocity.x = (v.velocity.x + v.net_force.x)*dampfactor;
				v.velocity.y = (v.velocity.y + v.net_force.y)*dampfactor;
			}
			
			//set new positions
			v = vertices[i];
			v.x += v.velocity.x; 
			v.y += v.velocity.y;
			
			v.x=Math.min(v.x,FlxG.width-10);
			v.y=Math.min(v.y,FlxG.height-10);
			v.x=Math.max(v.x,0+10);
			v.y=Math.max(v.y,0+10);
		}
	}
	
	public function GraphState()
	{
		edges = new Vector.<IntPair>();
		vertices = new Vector.<Vertex>();
	}
	
	public function Copy():GraphState
	{
		var g:GraphState = new GraphState();
		var i:int;
		for (i=0;i<edges.length;i++)
		{
			g.edges.push(new IntPair(edges[i].a,edges[i].b));
		}
		for (i=0;i<vertices.length;i++)
		{
			g.vertices.push(new Vertex(vertices[i].x,vertices[i].y,vertices[i].type));
		}
		return g;
	}
	
	//graph with one vertex
	public static function TerminalGraph():GraphState
	{
		var g:GraphState = new GraphState();
		g.vertices.push(new Vertex(0,0));
		return g;
	}
	
	//move vertices to lie on a grid in a rectangle (treated as a square)
	public function Gridify(r:Rectangle):void
	{
		var n : int  = Math.ceil(Math.sqrt(vertices.length));
		for (var i:int=0;i<n;i++)
		{
			for (var j:int=0;j<n;j++)
			{
				var k:int=i*n+j;
				if (k>=vertices.length)
					break;
				
				vertices[k].x=r.left+(r.right-r.left)*i/n;
				vertices[k].y=r.top +(r.bottom-r.top)*j/n;
			}
		}
	}
	
	public static function RandRange(Low:int,High:int):int
	{
		return Math.floor(Math.random()*(1+High-Low))+Low;
	}
	
	public static function RandomKernel(init:Boolean):GraphState
	{
		var k:GraphState = GraphState.TerminalGraph ();
		
		var connectedvertexcount:int = 3;//RandRange(3,5);
		//if (init)
		//{
		//	connectedvertexcount=RandRange(2,6);
		//}
		
		for (var i:int=0;i<connectedvertexcount;i++)
		{
			k.vertices.push(new Vertex(0,0));
			k.edges.push(new IntPair(0,k.vertices.length-1));
		}
		
		//add random extra connections here between the non-zero edges
		
		for (i=0;i<connectedvertexcount;i++)
		{
			if (Math.random()>0.5)
			{
				k.edges.push(new IntPair(1+i,1+((i+1)%connectedvertexcount)));
			}
		}
		return k;
	}
	
	public static function JoinGraphs(a:GraphState,b:GraphState):GraphState
	{
		var newstate:GraphState = a.Copy();
		for (i=0;i<b.edges.length;i++)
		{
			newstate.edges.push(new IntPair(b.edges[i].a+a.vertices.length,b.edges[i].b+a.vertices.length));
		}
		for (var i:int=0;i<b.vertices.length;i++)
		{
			newstate.vertices.push(new Vertex(b.vertices[i].x,b.vertices[i].y));
		}
		return newstate
	}
	
	public function randomVertexWeightedByConnections():int
	{
		return RandRange(0,vertices.length-1);
		
		var count:int=0;
		for (var i:int=0;i<vertices.length;i++)
		{
			if (vertices[i].type==2)
			{
				//	continue
			}
			count+=this.connectionsfrom(i);
			
		}
		
		var r:int=RandRange(0,count-1);
		
		for (i=0;i<vertices.length;i++)
		{
			if (vertices[i].type==2)
			{
				//	continue
			}
			r-=connectionsfrom(i);
			if (r<0)
				return i
		}
		
		return vertices.length-1;
	}
	
	
	private function RemoveDuplicateEdges():void
	{
		for (var i:int=0;i<edges.length;i++)
		{
			for (var j:int=i+1;j<edges.length;j++)
			{
				var edgea:IntPair = edges[i];
				var edgeb:IntPair = edges[j];
				if( (edgea.a==edgeb.a && edgea.b==edgeb.b) || (edgea.b==edgeb.a && edgea.a==edgeb.b) || (edgeb.a==edgeb.b))
				{
					edges.splice(j,1);
					j--;
				}
			}
		}
	}
	public function VertexNeighbours(v:int) : Vector.<int>
	{		
		var result:Vector.<int> = new Vector.<int>();
		for (var i:int=0;i<edges.length;i++)
		{
			var edge:IntPair = edges[i];
			if (edge.a==v)
			{
				if (result.indexOf(edge.b)==-1)
				{
					result.push(edge.b);
				}
			}
			if (edge.b==v)
			{
				if (result.indexOf(edge.a)==-1)
				{
					result.push(edge.a);
				}
			}
		}
		return result;
	}
	
	public function SuckOperation(suckingto:int):void
	{
		var suckingverts : Vector.<int> = VertexNeighbours(suckingto);
		
		//change edges
		for (var i:int = 0 ; i < suckingverts.length;i++)
		{
			RerouteEdges(suckingverts[i],suckingto);
		}
		
		RemoveDuplicateEdges();
		
		//now can safely remove vertices
		for (i=0;i<suckingverts.length;i++)
		{
			TryRemoveVertex(suckingverts[i]);
			
			for (var j:int=0;j<suckingverts.length;j++)
			{
				if (suckingverts[j]>suckingverts[i])
				{
					suckingverts[j]--;
				}
			}
		}
	}
	
	public function ChanceOfWinning():Number
	{
		if (vertices.length==1)
		{
			return 1;
		}
		
		var choicecount:int=0;
		var accumulated:Number=0;
		for (var i:int=0;i<vertices.length;i++)
		{
			if (connectionsfrom(i)==3)
			{
				choicecount++;
				var gp:GraphState=this.Copy();
				gp.SuckOperation(i);
				accumulated+=gp.ChanceOfWinning();				
			}
		}
		
		if (choicecount==0)
		{
			return 0;
		}
		else
		{
			return accumulated/choicecount;
		}
	}
	
	public function CanWin():Boolean
	{
		if (vertices.length==1)
		{
			return true;
		}
		else
		{			
			for (var i:int=0;i<vertices.length;i++)
			{
				if (connectionsfrom(i)==3)
				{
					var gp:GraphState=this.Copy();
					gp.SuckOperation(i);
					if (gp.CanWin())
					{
						return true;
					}
				}
			}
			
			return false;
		}
	}
	
	public static function EndGameSearch(maxdat:GenStruct):void
	{	
		for (var n:int=0;n<maxdat.totick;n++)
		{
			//trace(n.toString());
			var g:GraphState = GenerateGraph(5);
			var wincount:int=0;
			var losecount:int=0;
			
			for (var i:int=0;i<g.vertices.length;i++)
			{
				if (g.connectionsfrom(i)==3)
				{
					var gp:GraphState=g.Copy();
					gp.SuckOperation(i);
					if (gp.CanWin())
					{
						wincount++;
					}
					else
					{
						losecount++;
					}
				}
			}
			
			var diff:int=losecount-wincount;
			if (diff>=maxdat.maxdiff)
			{
				maxdat.maxdiff=losecount-wincount;
				maxdat.maxwin=wincount;
				maxdat.maxlose=losecount;
				
				maxdat.curmax=g.Copy();
			}
			if (losecount>=wincount+3)
			{
				trace(wincount,losecount);
				trace(g.Write());		
			}
			/*
			var chanceofwinning:Number= g.ChanceOfWinning();
			
			if (chanceofwinning<0.2)
			{
			trace(chanceofwinning);
			trace(g.Write());
			}*/
		}
		//trace(maxdat.maxwin,maxdat.maxlose);
		//return curmax;
		
	}
	public static function GenerateGraph(n:int):GraphState
	{
		//	return GraphState.RandomKernel();
		
		var oldstate:GraphState=GraphState.TerminalGraph();
		
		var state:GraphState = oldstate;
		for (var l:int=0;l<n;l++)
		{
			var k:GraphState=GraphState.RandomKernel(l==0);
			
			state = JoinGraphs(oldstate,k);
			
			var vertexToSubstitute:int = oldstate.randomVertexWeightedByConnections();// GraphState.RandRange(0,oldstate.vertices.length-1);
			
			// reroute all existing connections to this vertex to a random vertex from the new graph
			
			for (var i:int=0;i<oldstate.edges.length;i++)
			{
				var edge:IntPair = state.edges[i];
				if (edge.a==vertexToSubstitute)
				{
					edge.a=RandRange(oldstate.vertices.length+1,state.vertices.length-1);
					
					for (var j:int=oldstate.vertices.length+1;j<state.vertices.length;j++)
					{
						if (Math.random()>0.75 && edge.a!=j)
						{
							state.edges.push(new IntPair(edge.b,j));	
						}
					}
				}
				if (edge.b==vertexToSubstitute)
				{
					edge.b=RandRange(oldstate.vertices.length+1,state.vertices.length-1);
					
					for (j=oldstate.vertices.length+1;j<state.vertices.length;j++)
					{
						if (Math.random()>0.75 && edge.b!=j)
						{
							state.edges.push(new IntPair(edge.a,j));	
						}
					}
				}				
			}
			
			var oldvertexcolor:uint = oldstate.vertices[vertexToSubstitute].type;
			
			//remove that vertex
			
			state.TryRemoveVertex(vertexToSubstitute);
			
			//try colouring new ones
			if (l==0)
			{
				//on first stage, colour one as a target, and the rest as evil 
				for (i=0;i<state.vertices.length;i++)
				{
					state.vertices[i].type = 2;//i==0 ? 1 : 2;
				}
			}
			else
			{
				//colour the new ones the colour of its parent
				for (i=0;i<k.vertices.length;i++)
				{
					state.vertices[oldstate.vertices.length-1+i].type=oldvertexcolor;
				}
			}
			
			oldstate=state;
		}
		
		return state;
	}
	
	private function RerouteEdges(oldedge:int,newedge:int):void
	{
		for (var i:int=0;i<edges.length;i++)
		{
			var e:IntPair = edges[i];
			
			if (e.a==oldedge)
			{
				e.a=newedge
			}
			if (e.b==oldedge)
			{
				e.b=newedge
			}
			
			if (e.a==e.b)
			{
				edges.splice(i,1);
				i--;
			}												
		}		
	}
	
	public function TryAddEdge(p:IntPair):void
	{			
		if (p.a==p.b)
			return;
		
		for (var i:int=0;i<edges.length;i++)
		{
			var e:IntPair=edges[i];
			if ((e.a==p.a && e.b==p.b)||(e.b==p.a && e.a==p.b))
			{
				return;
			}			
		}
		edges.push(p);
	}
	
	public function TryRemoveEdge(e:int):void
	{
		edges.splice(e,1);
	}
	
	
	//flat out removes a vertex, and all edges associated with it
	public function TryRemoveVertex(fromindex:int):void
	{
		vertices.splice(fromindex,1);
		for (var i:int=0;i<edges.length;i++)
		{
			var e:IntPair = edges[i];
			
			if (e.a==fromindex||e.b==fromindex)
			{
				edges.splice(i,1);
				i--;
			}
			else
			{	
				
				if (e.a>fromindex)				
				{
					e.a--;
				}
				if (e.b>fromindex)
				{
					e.b--;
				}
			}
		}		
	}
}

class IntPair
{
	public var a:int;
	public var b:int;
	public function IntPair(_a:int,_b:int)
	{
		a=_a;
		b=_b;
	}
}